<script setup lang="ts">
import { ref, computed, onMounted, watch } from "vue";
import { useQuasar } from "quasar";
import { useRouter } from "vue-router";

import http from "@/plugins/http";
import config from "@/app.config";
import { useEvaluateStore } from "@/modules/06_evaluate/store";
import { useCounterMixin } from "@/stores/mixin";
import { useDataStore } from "@/stores/data";

/** import Components*/
import TableListEvaluate from "@/modules/06_evaluate/components/TableListEvaluate.vue"; // ตารางประเมิน
import DialogMain from "@/modules/06_evaluate/components/DialogMain.vue"; // popup การเพิ่มประเมิน

/** import Type*/
import type { ListMenu } from "@/modules/06_evaluate/interface/evalute";
import type { OptionStatus } from "@/modules/06_evaluate/interface/main";

/** use*/
const $q = useQuasar();
const mixin = useCounterMixin();
const store = useEvaluateStore();
const dataStore = useDataStore();
const router = useRouter();
const { showLoader, hideLoader, messageError } = mixin;

/** ตัวแปร*/
const modal = ref<boolean>(false);
const menu = ref<ListMenu>();
const listMenu = ref<ListMenu[]>([
  {
    val: "EXPERT",
    label: "ประเมินชำนาญการ",
    type: 2,
    level: 2,
  },
  {
    val: "SPECIAL_EXPERT",
    label: "ประเมินชำนาญการพิเศษ",
    type: 2,
    level: 3,
  },
  {
    val: "PROFESSIONAL",
    label: "ประเมินเชี่ยวชาญ",
    type: 2,
    level: 4,
  },
]);

const total = ref<number>(0);
const totalList = ref<number>(1);
const pagination = ref({
  sortBy: "createdAt",
  descending: true,
  page: 1,
  rowsPerPage: 10,
});

/**
 * function เปืด popup เพิ่มการประเมิน
 * @param data
 */
function onclickAddEvaluate(data: ListMenu) {
  modal.value = !modal.value;
  menu.value = data;
}

function openExpert() {
  router.push("/evaluate/expert");
}

/** function เรียกรายการประเมิน*/
async function fetchEvaluteList() {
  showLoader();
  const body = {
    page: pagination.value.page,
    pageSize: pagination.value.rowsPerPage,
    keyword: store.filterKeyword,
    status: selectedStatus.value,
  };
  await http
    .put(config.API.evaluationList(), body)
    .then(async (res) => {
      totalList.value = Math.ceil(
        res.data.result.total / pagination.value.rowsPerPage
      );
      total.value = res.data.result.total;
      store.fetchEvaluateList(res.data.result.data);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** function เรียกรายการประเมิน*/
const statusSubmit = ref<boolean>(true);
async function getProfileCheck() {
  if (!dataStore.dataprofilePosition) {
    await http
      .get(config.API.profilePosition())
      .then(async (res: any) => {
        const data = res.data.result;
        checkProfilePosition(data);
      })
      .catch((err) => {
        messageError($q, err);
      });
  } else {
    const data = dataStore.dataprofilePosition;
    checkProfilePosition(data);
  }
}

function checkProfilePosition(data: any) {
  if (
    data.posTypeRank != 2 ||
    (data.posTypeRank == 2 && data.posLevelRank >= 4)
  ) {
    statusSubmit.value = false;
  } else {
    listMenu.value = listMenu.value.filter(
      (x: ListMenu) => x.level > data.posLevelRank
    );
  }
}

const selectedStatus = ref<string[]>([
  "CHECK_SPEC",
  "PREPARE_DOC_V1",
  "CHECK_DOC_V1",
  "WAIT_CHECK_DOC_V1",
  "ANNOUNCE_WEB",
  "PREPARE_DOC_V2",
  "WAIT_CHECK_DOC_V2",
  "CHECK_DOC_V2",
]);
const options = ref<OptionStatus[]>([]);
const optionsMain = ref<OptionStatus[]>([
  { val: "CHECK_SPEC", label: "ตรวจสอบคุณสมบัติด้วยตนเอง" },
  { val: "PREPARE_DOC_V1", label: "จัดเตรียมเอกสารเล่ม 1" },
  { val: "CHECK_DOC_V1", label: "ตรวจสอบเอกสารเล่ม 1" },
  { val: "WAIT_CHECK_DOC_V1", label: "รอตรวจสอบคุณสมบัติ" },
  { val: "ANNOUNCE_WEB", label: "ประกาศบนเว็บไซต์" },
  { val: "PREPARE_DOC_V2", label: "จัดเตรียมเอกสารเล่ม 2" },
  { val: "WAIT_CHECK_DOC_V2", label: "ตรวจสอบเอกสารเล่ม 2" },
  { val: "CHECK_DOC_V2", label: "รอพิจารณาผลการประเมิน" },
  { val: "DONE", label: "เสร็จสิ้น" },
]);

/** ชื่อค่าที่ค้นหาสภานะ*/
const label = computed(() => {
  const filterOption = optionsMain.value.filter((option) =>
    selectedStatus.value.includes(option.val)
  );
  const labelval = filterOption.map((e) => e.label);
  if (labelval.length !== 0) {
    return labelval.length <= 2
      ? `${labelval.slice(0, 2).join(", ")}`
      : `${labelval.slice(0, 2).join(", ")}, อื่นๆ (${labelval.length - 2})`;
  } else return "";
});

/**
 * function ต้นหาข้อมูลของ Option ขอสถานะ
 * @param val ค่าที่ต้องการฟิลเตอร์
 * @param update  อัพเดทค่า
 * @param refData ดาต้าที่ต้องการฟิลเตอร์
 */
function filterOption(val: any, update: Function) {
  update(() => {
    options.value = optionsMain.value.filter(
      (v: any) => v.label.indexOf(val) > -1
    );
  });
}

watch(
  () => store.filterKeyword,
  async () => {
    store.filterKeyword === "" && (await fetchEvaluteList());
  }
);

function getSearch() {
  pagination.value.page = 1;
  fetchEvaluteList();
}

watch(
  () => pagination.value.rowsPerPage,
  async () => {
    getSearch();
  }
);

/** hook lifecycle*/
onMounted(async () => {
  await fetchEvaluteList();
  await getProfileCheck();
});
</script>

<template>
  <div class="col-12 row justify-center">
    <div class="col-xs-12 col-sm-12 col-md-11">
      <div class="toptitle text-white col-12 row items-center">
        <q-btn
          icon="mdi-arrow-left"
          unelevated
          round
          dense
          flat
          color="primary"
          class="q-mr-sm"
          @click="router.push('/')"
        />
        <div>ประเมินบุคคล</div>
      </div>
    </div>

    <div class="col-xs-12 col-sm-12 col-md-11 row q-col-gutter-md">
      <div class="col-12 row">
        <q-card bordered class="col-12 row caedNone q-pa-md">
          <div class="row col-12 q-mb-sm q-col-gutter-sm">
            <div class="col-xs-12 col-sm-3 col-md-2">
              <q-btn
                v-if="statusSubmit"
                flat
                round
                color="primary"
                icon="mdi-plus"
              >
                <q-menu>
                  <q-list style="min-width: auto">
                    <q-item
                      v-for="(item, index) in listMenu"
                      :key="index"
                      clickable
                      v-close-popup
                      @click.stop="
                        item.val == 'PROFESSIONAL'
                          ? openExpert()
                          : onclickAddEvaluate(item)
                      "
                    >
                      <q-item-section>{{ item.label }}</q-item-section>
                      <q-tooltip>{{ item.label }}</q-tooltip>
                    </q-item>
                  </q-list>
                </q-menu>
                <q-tooltip>เพิ่มการประเมินบุคคล</q-tooltip>
              </q-btn>
            </div>
            <q-space />
          </div>
          <div class="row col-12 q-mb-sm q-col-gutter-sm">
            <div class="col-xs-12 col-sm-3 col-md-2">
              <q-select
                dense
                outlined
                multiple
                v-model="selectedStatus"
                emit-value
                map-options
                :options="options"
                option-value="val"
                label="ค้นหาสถานะ"
                :style="!$q.screen.gt.xs ? '' : 'width: 35vw'"
                @update:model-value="getSearch"
                use-input
                @filter="(inputValue:any,doneFn:Function) => filterOption(inputValue, doneFn) "
              >
                <template v-slot:selected>
                  <div>
                    {{ label }}
                  </div>
                </template>
                <template v-slot:no-option>
                  <q-item>
                    <q-item-section class="text-grey">
                      ไม่มีข้อมูล
                    </q-item-section>
                  </q-item>
                </template>
              </q-select>
            </div>
            <q-space />
            <div class="col-xs-12 col-sm-3 col-md-2">
              <q-input
                dense
                outlined
                v-model="store.filterKeyword"
                label="ค้นหา"
                debounce="300"
                @keydown.enter.prevent="getSearch"
              >
                <template v-slot:append>
                  <q-icon name="search" />
                </template>
              </q-input>
            </div>
            <div class="col-xs-12 col-sm-3 col-md-2">
              <q-select
                v-model="store.visibleColumns"
                multiple
                outlined
                dense
                options-dense
                :display-value="$q.lang.table.columns"
                emit-value
                map-options
                :options="store.columns"
                option-value="name"
                style="min-width: 140px"
              />
            </div>
          </div>
          <div class="col-12">
            <TableListEvaluate
              :fetchData="fetchEvaluteList"
              v-model:total="total"
              v-model:total-list="totalList"
              v-model:pagination="pagination"
            />
          </div>
        </q-card>
      </div>
    </div>
  </div>

  <DialogMain :modal="modal" :menu="menu" :close="onclickAddEvaluate" />
</template>

<style lang="scss" scoped></style>
